/*
 * jQuery floating plugin v0.2
 * スクロールにぬるぬるついてくるやつ。
 *
 * Copyright (C) 2008 ichi http://ichi.fool.jp/memo/ 
 *
 * MIT License
 * http://www.opensource.org/licenses/mit-license.php
 */
(function($){

$.fn.floating = function(options){
	
	options = $.extend({
		wait: 100,
		minDuration: 100,
		check: 1000
	}, options);
	
	return this.each(function(){
		var $this = $(this);
		
		//safariはfixedでお茶濁し
		if($.browser.safari){
			$this.css("position", "fixed");
			return true;//continue
		}
		
		var boxTop = function(){return $this.offset().top};
		var startTop = boxTop();
		
		var timer, checkTimer;
		var scrollTop, nowTop, targetTop, duration;
		var d = document, w = window;
		
		var getPosTop = function(){
			scrollTop = d.body.scrollTop || d.documentElement.scrollTop;
			nowTop = boxTop();
			targetTop = scrollTop + startTop;
			duration = Math.max(options.minDuration, Math.abs(targetTop - nowTop));
		};
		
		var scrollAnimation = function(){
			$this
				.animate({
					top: targetTop + "px"
				}, duration, function(){
					timer = 0;
				});
		};
		
		$(w)
			.scroll(function(){
				if(timer) return;
				timer = w.setTimeout(function(){
					getPosTop();
					scrollAnimation();
				}, options.wait);
			});
		
		//定期的にチェック checkが0ならスルー
		if(options.check)
			checkTimer = w.setInterval(function(){
				if(timer) return;
				getPosTop();
				if(nowTop == targetTop) return;
				scrollAnimation();
			}, options.check);
		
	});
};


})(jQuery);
